$!
$!  Backup Icon directory for distribution.
$!  (assumes that [-.v8] is top level of file hierarchy)
$!
$!  Clean up the area.
$!
$ @clean
$ delete/noconfirm/nolog [.ipl.ucode]*.*;*, [.ipl.icode]*.*;*
$
$ DIR = f$environment("DEFAULT")
$ ERRSTR = "Usage:  @backup output-file-spec"
$ if p1 .eqs. "" then $ goto error
$ OUTFILE = f$parse("''p1'","Icon8",,,"syntax_only")
$
$ PDEV = f$parse(f$environment("procedure"),,,"device","no_conceal")
$ PDIR = f$parse(f$environment("procedure"),,,"directory")
$ set default 'PDIR'
$
$ IDIR = f$elememt(0,"]",f$parse("[-]",,,"directory"))
$ assign/nolog 'PDEV''IDIR'.] ICON /translation=(concealed,terminal)
$ ERRSTR = "Files are missing from ICON:[V8.BIN]"
$ if f$search("ICON:[v8.bin]icon.hlb")    .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]rtt.exe")     .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]icont.exe")   .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]iconx.exe")   .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]iconc.exe")   .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]rt.h")        .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]rt.db")       .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]rt.olb")      .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]dlrgint.obj") .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]grttin.h")    .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]deficon.com") .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]iexe.com")    .eqs. "" then $ goto error
$ if f$search("ICON:[v8.bin]X11.opt")     .eqs. "" then $ goto error
$
$ write sys$output "Copying VMS Icon hierarchy to ''OUTFILE'"
$ backup/interchange ICON:[v8...]*.* -
                     'OUTFILE'/rewind/save_set/density=1600/block_size=8192
$ set default 'DIR'
$ exit 1
$
$error:
$ write sys$output "''ERRSTR'"
$ write sys$output "No backup done"
$ set default 'DIR'
$ exit 1
