$!
$! Define the directory containing this procedure as ICON_BIN.
$!
$ PROC = f$environment("procedure")
$ DEV  = f$parse(PROC,,,"device")
$ DIR  = f$parse(PROC,,,"directory")
$ assign/nolog 'DEV''DIR' ICON_BIN
$!
$! Define the commands ICONT, ICONX, and IEXE.
$!
$ iconc == "$ ICON_BIN:iconc"
$ icont == "$ ICON_BIN:icont"
$ iconx == "$ ICON_BIN:iconx"
$ iexe  == "@ICON_BIN:iexe"
$!
$! Add the Icon help library to the help search path.
$!
$ HELPLIB = "ICON_BIN:ICON.HLB"		! value must be upper case
$ LIBNAME = "HLP$LIBRARY"
$ N = 0
$loop1:
$ NAMEVAL = f$trnlnm("''LIBNAME'","LNM$PROCESS_TABLE")
$ if NAMEVAL .eqs. ""           then $ goto assign1
$ if NAMEVAL .eqs. "''HELPLIB'" then $ goto done1
$ N = N + 1
$ LIBNAME = "HLP$LIBRARY_''N'"
$ if N .lt. 1000                then $ goto loop1
$ write sys$output "Can't add Icon help library; too many names."
$ goto done1
$
$assign1:
$ assign 'HELPLIB' 'LIBNAME'
$done1:
$!
$! Add the C library to the link search path.
$!
$ LINKLIB = "SYS$LIBRARY:VAXCRTL"	! value must be upper case
$ LIBNAME = "LNK$LIBRARY"
$ N = 0
$loop2:
$ NAMEVAL = f$trnlnm("''LIBNAME'","LNM$PROCESS_TABLE")
$ if NAMEVAL .eqs. ""                 then $ goto assign2
$ if (NAMEVAL .eqs. "''LINKLIB'") .or. -
     (NAMEVAL .eqs. "''LINKLIB'.OLB") then $ goto done2
$ N = N + 1
$ LIBNAME = "LNK$LIBRARY_''N'"
$ if N .lt. 1000                then $ goto loop2
$ write sys$output "Can't add C link library; too many names."
$ goto done2
$
$assign2:
$ assign 'LINKLIB' 'LIBNAME'
$done2:
$
$ exit 1
