$!
$! @test the preprocessor.
$!
$ set default [--.src.preproc]
$ @make
$ set default [--.tests.preproc]
$!
$! test conditional compilation
$!
$ @test-pp condexpr.out "condexpr.c"
$ @test-pp elif.out     "elif.c"
$ @test-pp emptyif.out  "emptyif.c"
$ @test-pp nestif.out   "nestif.c"
$ @test-pp variants.out "variants.c"
$!
$! test errors in conditional compilation
$!
$ @test-pp errif1.out  "errif1.c"
$ @test-pp errif2.out  "errif2.c"
$ @test-pp errif3.out  "errif3.c"
$ @test-pp errif4.out  "errif4.c"
$ @test-pp errif5.out  "errif5.c"
$ @test-pp errif6.out  "errif6.c"
$ @test-pp errif7.out  "errif7.c"
$ @test-pp errif8.out  "errif8.c"
$ @test-pp errif9.out  "errif9.c"
$ @test-pp errif10.out "errif10.c"
$ @test-pp errif11.out "errif11.c"
$ @test-pp errif12.out "errif12.c"
$!
$! test macros
$!
$ @test-pp define.out   "define.c"
$ @test-pp begdef.out   "begdef.c"
$ @test-pp undef.out    "undef.c"
$ @test-pp macargs.out  "macargs.c"
$ @test-pp stringiz.out "stringiz.c"
$ @test-pp paste.out    "paste.c"
$ @test-pp macnest.out  "macnest.c"
$ @test-pp special.out  "special.c"
$ @test-pp recurse.out  "recurse.c"
$ @test-pp redef.out    "redef.c"
$ @test-pp std1.out     "std1.c"
$ @test-pp std2.out     "std2.c"
$!
$! test macro errors
$!
$ @test-pp errmac1.out  "errmac1.c"
$ @test-pp errmac2.out  "errmac2.c"
$ @test-pp errmac3.out  "errmac3.c"
$ @test-pp errmac4.out  "errmac4.c"
$ @test-pp errmac5.out  "errmac5.c"
$ @test-pp errmac6.out  "errmac6.c"
$ @test-pp errmac7.out  "errmac7.c"
$ @test-pp errmac8.out  "errmac8.c"
$ @test-pp errmac9.out  "errmac9.c"
$ @test-pp errmac10.out "errmac10.c"
$ @test-pp errmac11.out "errmac11.c"
$ @test-pp errmac12.out "errmac12.c"
$ @test-pp errmac13.out "errmac13.c"
$ @test-pp errmac14.out "errmac14.c"
$ @test-pp errmac15.out "errmac15.c"
$ @test-pp errmac16.out "errmac16.c"
$ @test-pp errmac17.out "errmac17.c"
$ @test-pp errmac18.out "errmac18.c"
$ @test-pp errmac19.out "errmac19.c"
$ @test-pp errmac20.out "errmac20.c"
$ @test-pp errmac21.out "errmac21.c"
$!
$! test #include directives
$!
$ @test-pp sys.out     "sys.c"
$ @test-pp include.out "include.c"
$!
$! test errors in #include directives
$!
$ @test-pp errinc1.out "errinc1.c"
$ @test-pp errinc2.out "errinc2.c"
$ @test-pp errinc3.out "errinc3.c"
$ @test-pp errinc4.out "errinc4.c"
$!
$! test #line directive
$!
$ @test-pp line.out    "line.c"
$ @test-pp linemac.out "linemac.c"
$!
$! test errors in #line directive
$!
$ @test-pp errlin1.out "errlin1.c"
$ @test-pp errlin2.out "errlin2.c"
$ @test-pp errlin3.out "errlin3.c"
$ @test-pp errlin4.out "errlin4.c"
$!
$! test misc directives: #error, #pragma, and #
$!
$ @test-pp error1.out "error1.c"
$ @test-pp error2.out "error2.c"
$ @test-pp pragma.out "pragma.c"
$!
$! test how various combinations of white space, including new lines
$!  delimit preprocessor directives
$!
$ @test-pp delim1.out "delim1.c"
$ @test-pp delim2.out "delim2.c"
$!
$! test the generation of #line directives
$!
$ @test-pp glnargs.out  "glnargs.c"
$ @test-pp glncond.out  "glncond.c"
$ @test-pp glnincl.out  "glnincl.c"
$ @test-pp glnmulti.out "glnmulti.c"
$!
$! test string concatenation
$!
$ @test-pp concat.out  "concat.c"
$ @test-pp wh_sp.out   "wh_sp.c"
$ @test-pp oct_hex.out "oct_hex.c"
$!
$! test misc: trigraphs, empty file, misssing final new line, and comments
$!
$ @test-pp trigraph.out "trigraph.c"
$ @test-pp empty.out    "empty.c"
$ @test-pp miss_nl.out  "miss_nl.c"
$ @test-pp comments.ou1 "comments.c"
$ @test-pp comments.ou2 "-C" "comments.c"
$!
$! test command line options and arguments
$!
$ @test-pp cmdopt.ou1   "cmdopt.c"
$ @test-pp cmdopt.ou2   "-C" "-U__RCRS__" "cmdopt.c"
$ @test-pp cmdopt.ou3   "-P" "-Dtesting=" "cmdopt.c"
$ @test-pp cmdopt.ou4   "-P" "-C" """'-Dtesting=   test of -D  '""<cmdopt.c"
$ @test-pp cmdopt.ou5   "-Dtesting" "cmdopt1.c" "-" "cmdopt1.c" "<cmdopt.c"
$ @test-pp inclsrch.out "-Idir1" "-Idir2" "inclsrch.c"
$!
$! test erroneous command line options and arguments
$!
$ @test-pp errcmd.ou1 "missing.c"
$ @test-pp errcmd.ou2 "-a" "dummy.c"
$ @test-pp errcmd.ou3 "-D" "dummy.c"
$ @test-pp errcmd.ou4 "-D7" "dummy.c"
$ @test-pp errcmd.ou5 "-Dx-" "dummy.c"
$ @test-pp errcmd.ou6 "-U"
$ @test-pp errcmd.ou7 "-U-" "dummy.c"
$ @test-pp errcmd.ou8 "-U__RCRS__=" "dummy.c"
$ @test-pp errcmd.ou9 "dummy.c" "-Dx"
$
$ exit 1
