$!
$! Run a list of Icon tests using the compiler.
$! p1 = directory containing tests
$! p2 = name of file containing list
$! p3-p5 = arguments to iconc (optional)
$!
$ set noon
$ @[-.bin]deficon
$ on control_y then $ goto done
$
$ set default [.'p1']
$
$ open/read tlist 'p2'.lst
$ write sys$output "Running ''p2' tests:"
$loop:
$ read/end=done tlist name
$ write sys$output " Compiling ''name'"
$ if p5 .nes. ""
$ then iconc -s 'p3' 'p4' 'p5' 'name'.icn
$ else if p4 .nes. ""
$      then iconc -s 'p3' 'p4' 'name'.icn
$      else if p3 .nes. ""
$           then iconc -s 'p3' 'name'.icn
$           else iconc -s 'name'.icn
$           endif
$      endif
$ endif
$ write sys$output " Running ''name'"
$ define/user sys$output [.local]'name'.out
$ define/user sys$error  [.local]'name'.err
$ if f$search("''name'.dat") .nes. "" then $ define/user sys$input 'name'.dat
$ run 'name'.exe
$ write sys$output " Checking ''name'"
$ append [.local]'name'.err [.local]'name'.out
$ delete/noconfirm/nolog 'name'.exe;*, [.local]'name'.err;*
$ diff/output=[.local] [.local]'name'.out [.stand]'name'.out
$ if (($status .and. 7) .ne. 1) then $ goto failed
$ delete/noconfirm/nolog [.local]'name'.*;*
$ goto loop
$failed:
$ write sys$output "   --- output differs"
$ goto loop
$done:
$ close tlist
$
$ set default [-]
$
$ exit 1
